; LazyBrainBoot v0.6 - AGA compatible (no huh..)
; Max 23 files on disk
;


		;incdir	"asminclude:"
		incdir	"data:devel/asm/include_i/"
		include	"exec/types.i"
		include	"exec/libraries.i"
		include	"exec/macros.i"
		include	"exec/exec_lib.i"
		include	"exec/execbase.i"
		include	"graphics/gfx.i"
		include	"graphics/rastport.i"
		include	"graphics/graphics_lib.i"
		include	"graphics/text.i"
		include	"devices/trackdisk.i"


		rsreset
dmacon		rs.w	1
trackdisk	rs.l	1
membase		rs.l	1
gfxbase		rs.l	1
font		rs.l	1
sprxypos	rs.l	1

hashtable	rs.b	73*4
rastport	rs.b	rp_SIZEOF
bitmap		rs.b	bm_SIZEOF
textattr	rs.b	ta_SIZEOF

stackend	rs.l	0

;------------------------------------------------------------------------------
;Select OldFileSystem (1.2 & 1.3) or FastFileSystem (2.0+)
;------------------------------------------------------------------------------

_FFS		EQU	0
_OFS		EQU	1

FileType	EQU	_FFS

;		AUTO	ws\s\0\2\cc\

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

		section	dirboot,code_c

s:		IFNE	FileType
		dc.b	"DOS",0
		ELSE
		dc.b	"DOS",1
		ENDC
		dc.l	0
		dc.l	880


;------------------------------------------------------------------------------
;BootBlock starts - make space into the stack
;------------------------------------------------------------------------------
j:		movem.l	d1-d7/a1-a6,-(sp)
		lea	-stackend(sp),sp
		move.l	sp,a4
		;link	a4,#stackend
hardreg:	lea	$dff096,a5

;------------------------------------------------------------------------------
;Dma setup - screen to black
;------------------------------------------------------------------------------
		move.w	#320,d7
		move.w	#$20,$1dc-$96(a5)	; force pal
		move	$002-$96(a5),d0
		or	#$8000,d0
		move	#$01a0,(a5)
		clr	$180-$96(a5)
		clr.l	$00.w
		move.l	a4,a5			; lea	dmacon(a4),a5
		move	d0,(a5)+		; dmacon
		move.l	a1,(a5)+		; trackdisk

;------------------------------------------------------------------------------
;Allocate memory for sectorbuffer & bitplane (MEMF_CHIP)
;------------------------------------------------------------------------------
bytesize:	;move.l	#512+257*40,d0		; = $2a28
		moveq	#$2b00>>8,d0
		lsl	#8,d0
		move.l	#$10002,d1
		jsr	_LVOAllocMem(a6)
		move.l	d0,(a5)+		; membase
		move.l	d0,a3
		beq.b	alloc_error

;------------------------------------------------------------------------------
;Allocate memory for filenames (MEMF_PUBLIB)
;------------------------------------------------------------------------------
		moveq	#1,d1
		swap	d1
		moveq	#$104>>2,d6
		lsl.l	#2,d6
		;move.l	#32*23+4,d0		; = $2e4
		;moveq	#$2f0/16,d0
		;lsl	#4,d0
		;jsr	_LVOAllocMem(a6)
		;move.l	d0,CoolCapture(a6)	; Address to CoolCapture
		;move.l	d0,d6			; Loader takes care of this
		;beq.s	gfx_error		; after booting

;------------------------------------------------------------------------------
;Open graphics.library
;------------------------------------------------------------------------------
		lea	gfxlibname(pc),a1
		jsr	_LVOOldOpenLibrary(a6)
		move.l	d0,(a5)+		; gfxbase
		beq.s	gfx_error
		move.l	d0,a6

;------------------------------------------------------------------------------
;Initialize BitMap structure & pointers to bitplane
;------------------------------------------------------------------------------
		lea	bitmap(a4),a0
		move.l	a0,a2
		moveq	#1,d0
		move	d7,d1			; D1=320
		move	#200,d2
		jsr	_LVOInitBitMap(a6)
		lea	$200(a3),a3
		move.l	a3,bm_Planes(a2)

;------------------------------------------------------------------------------
;Initialize RasterPort structure
;------------------------------------------------------------------------------
		lea	rastport(a4),a1
		move.l	a1,a3
		jsr	_LVOInitRastPort(a6)
		move.l	a2,rp_BitMap(a3)	;a3=rastport <=> don't trash

;------------------------------------------------------------------------------
;Open topaz.font (rom)
;------------------------------------------------------------------------------
		lea	textattr+ta_SIZEOF(a4),a0
		lea	fontname(pc),a1
		move.l	#$00080000,-(a0)	;ta_YSize
		move.l	a1,-(a0)		;ta_Name
		jsr	_LVOOpenFont(a6)
		move.l	d0,(a5)+		;font

		clr.l	(a5)+			;sprxypos

;------------------------------------------------------------------------------
;And set font to topaz.font
;------------------------------------------------------------------------------
		move.l	d0,a0
		move.l	a3,a1
		jsr	_LVOSetFont(a6)

;------------------------------------------------------------------------------
;Call some subroutines
;------------------------------------------------------------------------------
		move.l	membase(a4),a2		;a2=secbuffer <=> don't trash
		bsr.s	printtitle
		bsr.s	getdir			;get file from root directory

		jsr	_LVODisable(a6)
		bsr	selector

;------------------------------------------------------------------------------
;Error exit part... restore system
;------------------------------------------------------------------------------
gfx_error:	;move.l	2+bytesize(pc),d0
		moveq	#$2b00>>8,d0
		lsl	#8,d0
		move.l	membase(a4),a1
		jsr	_LVOFreeMem(a6)

alloc_error:	;unlk	a4
		lea	stackend(sp),sp
		lea	doslibname(pc),a1
		move.w	#"do",(a1)
		jsr	_LVOFindResident(a6)
		movem.l	(sp)+,d1-d7/a1-a6
		move.l	d0,a0
		tst.l	d0
		beq.s	boot_error
		move.l	22(a0),a0
		moveq	#0,d0
		rts

boot_error:	moveq	#-1,d0
		rts

;------------------------------------------------------------------------------
;Get diskname...
;------------------------------------------------------------------------------
printtitle:	moveq	#16,d2			;used as y-counter
		lea	title(pc),a0

;------------------------------------------------------------------------------
;Print ascii string
;------------------------------------------------------------------------------
print:		move.w	d7,d0			; D0=320
		moveq	#0,d1
		move.l	a0,-(sp)
		move.b	(a0),d1
		lsl	#3,d1
		sub	d1,d0
		lsr	#1,d0

		move	d2,d1
		move.l	a3,a1
		move.l	gfxbase(a4),a6
		jsr	_LVOMove(a6)

		move.l	a3,a1
		move.l	(sp)+,a0
		moveq	#0,d0
		move.b	(a0)+,d0
		jmp	_LVOText(a6)

;------------------------------------------------------------------------------
;Get files from root directory
;------------------------------------------------------------------------------
getdir:		;addq.l	#4,d6

		move.w	#880,d0
		bsr.s	loadsector

		moveq	#36,d2
		lea	hashtable(a4),a5
		lea	6*4(a2),a0
hashloop:	move.l	(a0)+,d0
		bmi.s	hashend
		beq.s	hashloop
		move.l	d0,(a5)+
		bra.s	hashloop	

hashend:	clr.l	(a5)+
		lea	hashtable(a4),a5
dirloop:	move.l	(a5)+,d0
		beq.s	dirend

hashchain:	bsr.s	loadsector
		moveq	#-3,d0
		cmp.l	127*4(a2),d0
		bne.s	notfileheader

		btst	#1,80*4+3(a2)	; Executable file?
		bne.b	notfileheader

		lea	108*4(a2),a0
		move.l	d6,a1
		moveq	#32/4-1,d0
transname:	move.l	(a0)+,(a1)+
		dbf	d0,transname
		move.l	a1,d6
		lea	108*4(a2),a0
		bsr.s	print
		add	#10,d2

notfileheader:	move.l	124*4(a2),d0
		bne.s	hashchain
		bra.s	dirloop

dirend:		move	d2,d5
		sub	#38,d5

		move.l	trackdisk(a4),a1
		move	#TD_MOTOR,IO_COMMAND(a1)
		clr.l	IO_LENGTH(a1)
		bra.s	doio

;------------------------------------------------------------------------------
;Load one sector into sectorbuffer (a2)
;------------------------------------------------------------------------------
loadsector:	mulu	#512,d0
		move.l	trackdisk(a4),a1
		move.l	d0,(a0)
		move.l	d0,IO_OFFSET(a1)
		move.l	a2,IO_DATA(a1)
		move.l	#512,IO_LENGTH(a1)
		move	#CMD_READ,IO_COMMAND(a1)
doio:		move.l	$04.w,a6
		jmp	_LVODoIO(a6)

;------------------------------------------------------------------------------
;FileSelector - setup copperlist & sprite pointers & DMA
;------------------------------------------------------------------------------
selector:	move.l	hardreg+2(pc),a5
		move.l	a2,a0
		lea	coplist(pc),a1
		moveq	#(copend-coplist)/4-1,d0
transcop:	move.l	(a1)+,(a0)+
		dbf	d0,transcop
		move.l	a2,$080-$96(a5)
		lea	$200(a2),a0
		lea	pointer-coplist(a2),a3
		lea	spr-coplist+2(a2),a1
		lea	scrs-coplist+2(a2),a2

		move.l	a3,d0
		move	d0,4(a1)
		swap	d0
		move	d0,(a1)

		moveq	#2-1,d1
bplloop:	move.l	a0,d0
		move.w	d0,4(a2)
		swap	d0
		move.w	d0,(a2)
		lea	40(a0),a0
		addq.l	#8,a2
		dbf	d1,bplloop		
		move.w	#$83a0,(a5)

;------------------------------------------------------------------------------
;Move mouse pointer loop
;------------------------------------------------------------------------------
mouse:		cmp.b	#$ff,$006-$96(a5)
		bne.s	mouse

move_pointer:	move	$00a-$96(a5),d1
		lea	sprxypos(a4),a0
		move	d1,d3
		move.b	d1,d4
		lsr	#8,d3
		sub.b	(a0),d3
		sub.b	1(a0),d4
		move	d1,(a0)+		;sprxypos
		ext	d3
		ext	d4
		movem	(a0),d0/d2		;oldsprxypos
		add	d4,d0
		bpl.s	poineg1
		moveq	#0,d0
poineg1:	cmp.w	d7,d0			; 320
		blo.s	poipos1
		move	d7,d0			; D0=320
poipos1:	add	d3,d2
		bpl.s	poineg2
		moveq	#0,d2
poineg2:	cmp	d5,d2
		blo.s	poipos2
		move	d5,d2
		subq	#1,d2

poipos2:	movem	d0/d2,(a0)		;oldsprxypos
		moveq	#11,d4

;d0.l - xpos  d2.l - ypos

calc_sprite_pos:move.l	#$4a404a00,d1
		move.l	d2,d3
		lsl	#8,d3
		bcc.s	p2notset1
		addx.b	d1,d1
		swap	d3
		add.l	d3,d1
		bra.s	p2mscont1
p2notset1:	swap	d3
		add.l	d3,d1
		addx.b	d1,d1
p2mscont1:	add	d4,d2
		lsl	#8,d2
		bcc.s	p2notset2
		addx.b	d1,d1
		add	d2,d1
		bra.s	p2mscont2
p2notset2:	add	d2,d1
		addx.b	d1,d1
p2mscont2:	lsr	#1,d0
		addx.b	d1,d1
		swap	d0
		add.l	d0,d1

		move.l	d1,(a3)

		btst	#6,$bfe001
		bne.w	mouse

;------------------------------------------------------------------------------
;Exit part... restore system...
;------------------------------------------------------------------------------
		;move.l	CoolCapture(a6),a1
		move.l	(a0),$100.w

		move	#$7fff,(a5)
		move.l	gfxbase(a4),a6
		move.l	38(a6),$080-$96(a5)
		move.w	(a4),(a5)		;move	dmacon(a4),(a5)

		move.l	font(a4),a1
		jsr	_LVOCloseFont(a6)

		move.l	$04.w,a6
		jsr	_LVOEnable(a6)

		move.l	gfxbase(a4),a1
		jmp	_LVOCloseLibrary(a6)

;------------------------------------------------------------------------------
;All other datas...
;------------------------------------------------------------------------------
		dc.b	0
gfxlibname:	dc.b	"graph"
doslibname:	dc.b	"ics.library",0
fontname:	dc.b	"topaz.font",0
title:		dc.b	40
		dc.b	"LazyBrainBoot - (c) 1993 Mr.Spiv of CLX!"
eg:		cnop	0,4

coplist:	dc.l	$01002200,$01020010,$008e2c71,$00902cd1
		dc.l	$00920038,$009400d0,$01080000,$010a0000
		dc.l	$01040024,$01060c00,$010c0011,$01fc0000
scrs:		dc.l	$00e00000,$00e20000,$00e40000,$00e60000
spr:		dc.l	$01200000,$01220000,$01240000,$01260000
		dc.l	$01280000,$012a0000,$012c0000,$012e0000
		dc.l	$01300000,$01320000,$01340000,$01360000
		dc.l	$01380000,$013a0000,$013c0000,$013e0000
		dc.l	$0182089f,$0184045c,$01860fff
		dc.l	$01a20ade,$01a40145,$01a60058
		dc.l	$2b07fffe,$01800ccf,$2c07fffe,$01800000
		dc.l	$ffdffffe,$2c07fffe,$01800ccf
		dc.l	$2d07fffe,$01800113,$fffffffe

pointer:	dc.l	0
		dc.w	%1100000000000000,%0100000000000000
		dc.w	%0111000000000000,%1011000000000000
		dc.w	%0011110000000000,%0100110000000000
		dc.w	%0011111100000000,%0100001100000000
		dc.w	%0001111111000000,%0010000011000000
		dc.w	%0001111111000000,%0010000000000000
		dc.w	%0000111000000000,%0001000100000000
		dc.w	%0000110100000000,%0001001010000000
		dc.w	%0000010010000000,%0000100101000000
		dc.w	%0000010001000000,%0000100010100000
		dc.w	%0000000000100000,%0000000001000000
		dc.l	0


copend:		dcb.b	1024-(copend-s),0

e:
